From 85805cec905c8a19182ba7bc21dba78bc351bb2d Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Jan 03 2021 04:06:28 +0000
Subject: [PATCH 2004/2232] Turn off explicit instantiations in test suite on MSVC


MSVC warns about the ones that are specialized out of line.

    cxxbridge\include\rust/cxx.h(324): warning C4661: 'rust::cxxbridge1::Vec<uint8_t>::Vec(void) noexcept': no suitable definition provided for explicit template instantiation request
    cxxbridge\include\rust/cxx.h(269): note: see declaration of 'rust::cxxbridge1::Vec<uint8_t>::Vec'
    cxxbridge\include\rust/cxx.h(324): warning C4661: 'size_t rust::cxxbridge1::Vec<uint8_t>::size(void) noexcept const': no suitable definition provided for explicit template instantiation request
    cxxbridge\include\rust/cxx.h(278): note: see declaration of 'rust::cxxbridge1::Vec<uint8_t>::size'
    cxxbridge\include\rust/cxx.h(324): warning C4661: 'const T *rust::cxxbridge1::Vec<T>::data(void) noexcept const': no suitable definition provided for explicit template instantiation request
            with
            [
                T=uint8_t
            ]
    cxxbridge\include\rust/cxx.h(280): note: see declaration of 'rust::cxxbridge1::Vec<uint8_t>::data'
    cxxbridge\include\rust/cxx.h(324): warning C4661: 'size_t rust::cxxbridge1::Vec<uint8_t>::capacity(void) noexcept const': no suitable definition provided for explicit template instantiation request
    cxxbridge\include\rust/cxx.h(282): note: see declaration of 'rust::cxxbridge1::Vec<uint8_t>::capacity'

---

diff --git a/tests/ffi/build.rs b/tests/ffi/build.rs
index e583944..c8f010e 100644
--- a/tests/ffi/build.rs
+++ b/tests/ffi/build.rs
@@ -7,8 +7,11 @@ fn main() {
 
     CFG.include_prefix = "tests/ffi";
     let sources = vec!["lib.rs", "module.rs"];
-    cxx_build::bridges(sources)
-        .file("tests.cc")
-        .flag_if_supported(cxxbridge_flags::STD)
-        .compile("cxx-test-suite");
+    let mut build = cxx_build::bridges(sources);
+    build.file("tests.cc");
+    build.flag_if_supported(cxxbridge_flags::STD);
+    if cfg!(not(target_env = "msvc")) {
+        build.define("CXX_TEST_INSTANTIATIONS", None);
+    }
+    build.compile("cxx-test-suite");
 }
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 302944a..9c3c62a 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -848,6 +848,7 @@ std::unique_ptr<I> ns_c_return_unique_ptr_ns() {
 // > serves as an explicit instantiation of the same kind (declaration or
 // > definition) of each of its non-inherited non-template members that has not
 // > been previously explicitly specialized in the translation unit.
+#if defined(CXX_TEST_INSTANTIATIONS)
 template class rust::Box<tests::Shared>;
 template class rust::Slice<const char>;
 template class rust::Slice<const uint8_t>;
@@ -860,3 +861,4 @@ template class rust::Vec<uint8_t>;
 template class rust::Vec<rust::String>;
 template class rust::Vec<tests::Shared>;
 template class rust::Fn<size_t(rust::String)>;
+#endif

